/*
    tvrender for libview64
    (c) 1995-2013 Soci/Singular (soci at c64.rulez.org)

    $Id: tvrender.h 88 2016-04-24 16:42:35Z soci $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
#ifndef _TVRENDER_H
#define _TVRENDER_H

#include <stdio.h>
#include "libview64.h"

typedef enum {
    VIDEO_RGB = 0,
    VIDEO_PAL = 1,
    VIDEO_NTSC = 2,
    VIDEO_MASK = 3,
    VIDEO_CHROMA_NOISE = 4,
    VIDEO_SCANLINES = 8,
    VIDEO_SHADOWMASK = 16,
    VIDEO_NOLACE = 32,
    VIDEO_MONOCHROME = 64,
    VIDEO_OLD_LUMA = 128
} video_mode;

/* generic palette holder */
typedef struct {
    unsigned char r, g, b;
} rgb_color;

/* generic image holder */
typedef struct {
    int h;
    int w;
    int pitch;
    int scale;
    int colors;
    rgb_color *palette;
    unsigned char *d;
} tvrender_image;

#ifdef __cplusplus
extern "C" {
#endif

extern rgb_color *load_palette(FILE *f1);
extern tvrender_image *create_tvpicture(const view64_screen *, unsigned int, int, const rgb_color *);
extern int create_tvpicture_line(const tvrender_image *, unsigned int, int, int, int, unsigned char *);
extern void free_tv_pixels(tvrender_image *);
extern int colors_tvpicture(const view64_screen *, unsigned int);
extern int width_tvpicture(int, unsigned int, int);

#ifdef __cplusplus
}
#endif

#endif

