/*
    View64 configuration handler
    (c) 1995-2013 Soci/Singular (soci at c64.rulez.org)

    $Id: view64_config.h 47 2015-05-11 19:01:02Z soci $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
#ifndef _VIEW64_CONFIG_H
#define _VIEW64_CONFIG_H

#include <stdio.h>
#include "tvrender.h"

typedef struct {
    int fullscreen;
    unsigned int vmode;
    int save;
    int x, y, width, height, zoom, menu;
    char *filename;
    char *palette_filename;
} arguments_t;

#ifdef __cplusplus
extern "C" {
#endif

extern int ini_handler(void *, const char *, const char *, const char *);
extern void config_reset(arguments_t *);
extern void configure(int, char **, arguments_t *);
extern void ini_save_file(FILE *, const arguments_t *);
extern int config_changed(const arguments_t *);
extern void free_config(arguments_t *);

#ifdef __cplusplus
}
#endif

#endif

